Index: dll/win32/schannel/schannel_mbedtls.c
===================================================================
--- dll/win32/schannel/schannel_mbedtls.c	(revisión: 69439)
+++ dll/win32/schannel/schannel_mbedtls.c	(copia de trabajo)
@@ -664,30 +502,34 @@
 
 static ALG_ID schannel_get_kx_algid(int ciphersuite_id)
 {
-    const ssl_ciphersuite_t *cipher_suite = ssl_ciphersuite_from_id(ciphersuite_id);
+    const mbedtls_ssl_ciphersuite_t *cipher_suite = mbedtls_ssl_ciphersuite_from_id(ciphersuite_id);
 
     switch (cipher_suite->key_exchange)
     {
-        case POLARSSL_KEY_EXCHANGE_NONE:
-            return 0;
+        case MBEDTLS_KEY_EXCHANGE_NONE:
+        case MBEDTLS_KEY_EXCHANGE_PSK: /* the original implementation does not support    */
+            return 0;                  /* any PSK, and does not define any `CALG_PSK` :)  */
 
-        case POLARSSL_KEY_EXCHANGE_ECDH_RSA:
-        case POLARSSL_KEY_EXCHANGE_ECDH_ECDSA:
-        case POLARSSL_KEY_EXCHANGE_ECDHE_PSK:
-        case POLARSSL_KEY_EXCHANGE_ECDHE_RSA:
-            return CALG_ECDH;
-
-        case POLARSSL_KEY_EXCHANGE_RSA_PSK:
-        case POLARSSL_KEY_EXCHANGE_RSA:
+        case MBEDTLS_KEY_EXCHANGE_RSA:
+        case MBEDTLS_KEY_EXCHANGE_RSA_PSK:
             return CALG_RSA_KEYX;
 
-        case POLARSSL_KEY_EXCHANGE_DHE_PSK:
-        case POLARSSL_KEY_EXCHANGE_DHE_RSA:
+        case MBEDTLS_KEY_EXCHANGE_DHE_RSA:
+        case MBEDTLS_KEY_EXCHANGE_DHE_PSK:
             return CALG_DH_EPHEM;
 
+        case MBEDTLS_KEY_EXCHANGE_ECDH_RSA:
+        case MBEDTLS_KEY_EXCHANGE_ECDH_ECDSA:
+            return CALG_ECDH;
+
+        case MBEDTLS_KEY_EXCHANGE_ECDHE_RSA:
+        case MBEDTLS_KEY_EXCHANGE_ECDHE_ECDSA:
+        case MBEDTLS_KEY_EXCHANGE_ECDHE_PSK:
+            return CALG_ECDH_EPHEM;
+
         default:
         {
-            FIXME("POLARSSL schannel_get_kx_algid: unknown algorithm %d\n", cipher_suite->key_exchange);
+            FIXME("MBEDTLS schannel_get_kx_algid: unknown algorithm %d\n", cipher_suite->key_exchange);
             return 0;
         }
     }
@@ -695,38 +537,42 @@
 
 unsigned int schan_imp_get_session_cipher_block_size(schan_imp_session session)
 {
-    POLARSSL_SESSION *s = (POLARSSL_SESSION *)session;
-    TRACE("POLARSSL schan_imp_get_session_cipher_block_size %p.\n", session);
+    MBEDTLS_SESSION *s = (MBEDTLS_SESSION *)session;
 
-    return schannel_get_cipher_block_size(ssl_get_ciphersuite_id(ssl_get_ciphersuite(&s->ssl)));
+    unsigned int cipher_block_size = mbedtls_cipher_get_block_size(&s->ssl.transform->cipher_ctx_enc);
+
+    TRACE("MBEDTLS schan_imp_get_session_cipher_block_size %p returning %u.\n", session, cipher_block_size);
+
+    return cipher_block_size;
 }
 
 unsigned int schan_imp_get_max_message_size(schan_imp_session session)
 {
-    // POLARSSL_SESSION *s = (POLARSSL_SESSION *)session;
-    TRACE("POLARSSL schan_imp_get_max_message_size %p.\n", session);
+    MBEDTLS_SESSION *s = (MBEDTLS_SESSION *)session;
 
-    /* FIXME: update to mbedTLS 2.1.0 to use this function */
-    // return mbedtls_ssl_get_max_frag_len(&s->ssl);
-    return SSL_MAX_CONTENT_LEN;
+    unsigned int max_frag_len = mbedtls_ssl_get_max_frag_len(&s->ssl);
+
+    TRACE("MBEDTLS schan_imp_get_max_message_size %p returning %u.\n", session, max_frag_len);
+
+    return max_frag_len;
 }
 
 SECURITY_STATUS schan_imp_get_connection_info(schan_imp_session session,
                                               SecPkgContext_ConnectionInfo *info)
 {
-    POLARSSL_SESSION *s = (POLARSSL_SESSION *)session;
+    MBEDTLS_SESSION *s = (MBEDTLS_SESSION *)session;
 
-    int ciphersuite_id = ssl_get_ciphersuite_id(ssl_get_ciphersuite(&s->ssl));
+    int ciphersuite_id = mbedtls_ssl_get_ciphersuite_id(mbedtls_ssl_get_ciphersuite(&s->ssl));
 
-    TRACE("POLARSSL schan_imp_get_connection_info %p %p.\n", session, info);
+    TRACE("MBEDTLS schan_imp_get_connection_info %p %p.\n", session, info);
 
-    info->dwProtocol       = schannel_get_protocol(&s->ssl);
+    info->dwProtocol       = schannel_get_protocol(&s->ssl, &s->conf);
     info->aiCipher         = schannel_get_cipher_algid(ciphersuite_id);
     info->dwCipherStrength = schannel_get_cipher_key_size(ciphersuite_id);
     info->aiHash           = schannel_get_mac_algid(ciphersuite_id);
     info->dwHashStrength   = schannel_get_mac_key_size(ciphersuite_id);
     info->aiExch           = schannel_get_kx_algid(ciphersuite_id);
-    info->dwExchStrength   = schannel_get_kx_key_size(&s->ssl, ciphersuite_id);
+    info->dwExchStrength   = schannel_get_kx_key_size(&s->ssl, &s->conf, ciphersuite_id);
 
     return SEC_E_OK;
 }
@@ -734,21 +580,23 @@
 SECURITY_STATUS schan_imp_get_session_peer_certificate(schan_imp_session session, HCERTSTORE store,
                                                        PCCERT_CONTEXT *ret)
 {
-    POLARSSL_SESSION *s = (POLARSSL_SESSION *)session;
+    MBEDTLS_SESSION *s = (MBEDTLS_SESSION *)session;
     PCCERT_CONTEXT cert_context = NULL;
-    const x509_crt *next_cert;
 
-    TRACE("POLARSSL schan_imp_get_session_peer_certificate %p %p %p %p.\n", session, store, ret, ret != NULL ? *ret : NULL);
+    const mbedtls_x509_crt *next_cert;
+    const mbedtls_x509_crt *peer_cert = mbedtls_ssl_get_peer_cert(&s->ssl);
 
-    if (!s->ssl.session->peer_cert)
+    TRACE("MBEDTLS schan_imp_get_session_peer_certificate %p %p %p %p.\n", session, store, ret, ret != NULL ? *ret : NULL);
+
+    if (!peer_cert)
         return SEC_E_INTERNAL_ERROR;
 
-    for (next_cert = s->ssl.session->peer_cert; next_cert != NULL; next_cert = next_cert->next)
+    for (next_cert = peer_cert; next_cert != NULL; next_cert = next_cert->next)
     {
         if (!CertAddEncodedCertificateToStore(store, X509_ASN_ENCODING, next_cert->raw.p, next_cert->raw.len,
-            CERT_STORE_ADD_REPLACE_EXISTING, (next_cert != s->ssl.session->peer_cert) ? NULL : &cert_context))
+            CERT_STORE_ADD_REPLACE_EXISTING, (next_cert != peer_cert) ? NULL : &cert_context))
         {
-            if (next_cert != s->ssl.session->peer_cert)
+            if (next_cert != peer_cert)
                 CertFreeCertificateContext(cert_context);
             return GetLastError();
         }
@@ -761,16 +609,16 @@
 SECURITY_STATUS schan_imp_send(schan_imp_session session, const void *buffer,
                                SIZE_T *length)
 {
-    POLARSSL_SESSION *s = (POLARSSL_SESSION *)session;
+    MBEDTLS_SESSION *s = (MBEDTLS_SESSION *)session;
     int ret;
 
-    ret = ssl_write(&s->ssl, (unsigned char *)buffer, *length);
+    ret = mbedtls_ssl_write(&s->ssl, (unsigned char *)buffer, *length);
 
-    TRACE("POLARSSL schan_imp_send: (%p, %p, %p/%lu)\n", s, buffer, length, *length);
+    TRACE("MBEDTLS schan_imp_send: (%p, %p, %p/%lu)\n", s, buffer, length, *length);
 
     if (ret >= 0)
     {
-        TRACE("POLARSSL schan_imp_send: ret=%i.\n", ret);
+        TRACE("MBEDTLS schan_imp_send: ret=%i.\n", ret);
 
         *length = ret;
     }
@@ -780,18 +628,18 @@
 
         if (!*length)
         {
-            TRACE("POLARSSL schan_imp_send: ret=POLARSSL_ERR_NET_WANT_WRITE -> SEC_I_CONTINUE_NEEDED; len=%lu", *length);
+            TRACE("MBEDTLS schan_imp_send: ret=MBEDTLS_ERR_NET_WANT_WRITE -> SEC_I_CONTINUE_NEEDED; len=%lu", *length);
             return SEC_I_CONTINUE_NEEDED;
         }
         else
         {
-            TRACE("POLARSSL schan_imp_send: ret=POLARSSL_ERR_NET_WANT_WRITE -> SEC_E_OK; len=%lu", *length);
+            TRACE("MBEDTLS schan_imp_send: ret=MBEDTLS_ERR_NET_WANT_WRITE -> SEC_E_OK; len=%lu", *length);
             return SEC_E_OK;
         }
     }
     else
     {
-        ERR("POLARSSL schan_imp_send: ssl_write failed with -%x\n", -ret);
+        ERR("MBEDTLS schan_imp_send: mbedtls_ssl_write failed with -%x\n", -ret);
         return SEC_E_INTERNAL_ERROR;
     }
 
@@ -801,18 +649,18 @@
 SECURITY_STATUS schan_imp_recv(schan_imp_session session, void *buffer,
                                SIZE_T *length)
 {
-    PPOLARSSL_SESSION s = (PPOLARSSL_SESSION)session;
+    PMBEDTLS_SESSION s = (PMBEDTLS_SESSION)session;
     int ret;
 
-    TRACE("POLARSSL schan_imp_recv: (%p, %p, %p/%lu)\n", s, buffer, length, *length);
+    TRACE("MBEDTLS schan_imp_recv: (%p, %p, %p/%lu)\n", s, buffer, length, *length);
 
-    ret = ssl_read(&s->ssl, (unsigned char *)buffer, *length);
+    ret = mbedtls_ssl_read(&s->ssl, (unsigned char *)buffer, *length);
 
-    TRACE("POLARSSL schan_imp_recv: (%p, %p, %p/%lu) ret= %#x\n", s, buffer, length, *length, ret);
+    TRACE("MBEDTLS schan_imp_recv: (%p, %p, %p/%lu) ret= %#x\n", s, buffer, length, *length, ret);
 
     if (ret >= 0)
     {
-        TRACE("POLARSSL schan_imp_recv: ret == %i.\n", ret);
+        TRACE("MBEDTLS schan_imp_recv: ret == %i.\n", ret);
 
         *length = ret;
     }
@@ -822,23 +670,23 @@
 
         if (!*length)
         {
-            TRACE("POLARSSL schan_imp_recv: ret=POLARSSL_ERR_NET_WANT_WRITE -> SEC_I_CONTINUE_NEEDED; len=%lu", *length);
+            TRACE("MBEDTLS schan_imp_recv: ret=MBEDTLS_ERR_NET_WANT_WRITE -> SEC_I_CONTINUE_NEEDED; len=%lu", *length);
             return SEC_I_CONTINUE_NEEDED;
         }
         else
         {
-            TRACE("POLARSSL schan_imp_recv: ret=POLARSSL_ERR_NET_WANT_WRITE -> SEC_E_OK; len=%lu", *length);
+            TRACE("MBEDTLS schan_imp_recv: ret=MBEDTLS_ERR_NET_WANT_WRITE -> SEC_E_OK; len=%lu", *length);
             return SEC_E_OK;
         }
     }
-    else if (ret == POLARSSL_ERR_SSL_PEER_CLOSE_NOTIFY)
+    else if (ret == MBEDTLS_ERR_SSL_PEER_CLOSE_NOTIFY)
     {
-        TRACE("POLARSSL schan_imp_recv: ret == POLARSSL_ERR_SSL_PEER_CLOSE_NOTIFY -> SEC_E_OK\n");
+        TRACE("MBEDTLS schan_imp_recv: ret == MBEDTLS_ERR_SSL_PEER_CLOSE_NOTIFY -> SEC_E_OK\n");
         return SEC_E_OK;
     }
     else
     {
-        ERR("POLARSSL schan_imp_recv: ssl_read failed with -%x\n", -ret);
+        ERR("MBEDTLS schan_imp_recv: mbedtls_ssl_read failed with -%x\n", -ret);
         return SEC_E_INTERNAL_ERROR;
     }
 
@@ -847,7 +695,7 @@
 
 BOOL schan_imp_allocate_certificate_credentials(schan_credentials *c)
 {
-    TRACE("POLARSSL schan_imp_allocate_certificate_credentials %p %p %d\n", c, c->credentials, c->credential_use);
+    TRACE("MBEDTLS schan_imp_allocate_certificate_credentials %p %p %d\n", c, c->credentials, c->credential_use);
 
     /* in our case credentials aren't really used for anything, so just stub them */
     c->credentials = NULL;
@@ -856,18 +704,18 @@
 
 void schan_imp_free_certificate_credentials(schan_credentials *c)
 {
-    TRACE("POLARSSL schan_imp_free_certificate_credentials %p %p %d\n", c, c->credentials, c->credential_use);
+    TRACE("MBEDTLS schan_imp_free_certificate_credentials %p %p %d\n", c, c->credentials, c->credential_use);
 }
 
 BOOL schan_imp_init(void)
 {
-    TRACE("Schannel POLARSSL schan_imp_init\n");
+    TRACE("Schannel MBEDTLS schan_imp_init\n");
     return TRUE;
 }
 
 void schan_imp_deinit(void)
 {
-    WARN("Schannel POLARSSL schan_imp_deinit\n");
+    WARN("Schannel MBEDTLS schan_imp_deinit\n");
 }
 
 #endif /* SONAME_LIBMBEDTLS && !HAVE_SECURITY_SECURITY_H && !SONAME_LIBGNUTLS */
\ No newline at end of file
Index: dll/win32/schannel/schannel_mbedtls_lazyload.h
===================================================================
--- dll/win32/schannel/schannel_mbedtls_lazyload.h	(revisión: 69439)
+++ dll/win32/schannel/schannel_mbedtls_lazyload.h	(copia de trabajo)
@@ -24,28 +24,38 @@
 
 #define MAKE_FUNCPTR(f) static typeof(f) * p##f;
 
-MAKE_FUNCPTR(ctr_drbg_free)
-MAKE_FUNCPTR(ctr_drbg_init)
-MAKE_FUNCPTR(ctr_drbg_random)
-MAKE_FUNCPTR(entropy_free)
-MAKE_FUNCPTR(entropy_func)
-MAKE_FUNCPTR(entropy_init)
-MAKE_FUNCPTR(ssl_ciphersuite_from_id)
-MAKE_FUNCPTR(ssl_free)
-MAKE_FUNCPTR(ssl_get_ciphersuite)
-MAKE_FUNCPTR(ssl_get_ciphersuite_id)
-MAKE_FUNCPTR(ssl_get_version)
-MAKE_FUNCPTR(ssl_handshake)
-MAKE_FUNCPTR(ssl_init)
-MAKE_FUNCPTR(ssl_read)
-MAKE_FUNCPTR(ssl_set_authmode)
-MAKE_FUNCPTR(ssl_set_bio)
-MAKE_FUNCPTR(ssl_set_endpoint)
-MAKE_FUNCPTR(ssl_set_hostname)
-MAKE_FUNCPTR(ssl_set_max_version)
-MAKE_FUNCPTR(ssl_set_min_version)
-MAKE_FUNCPTR(ssl_set_rng)
-MAKE_FUNCPTR(ssl_write)
+MAKE_FUNCPTR(mbedtls_ctr_drbg_free)
+MAKE_FUNCPTR(mbedtls_ctr_drbg_init)
+MAKE_FUNCPTR(mbedtls_ctr_drbg_random)
+MAKE_FUNCPTR(mbedtls_entropy_free)
+MAKE_FUNCPTR(mbedtls_entropy_func)
+MAKE_FUNCPTR(mbedtls_entropy_init)
+MAKE_FUNCPTR(mbedtls_ssl_ciphersuite_from_id)
+MAKE_FUNCPTR(mbedtls_ssl_free)
+MAKE_FUNCPTR(mbedtls_ssl_get_ciphersuite)
+MAKE_FUNCPTR(mbedtls_ssl_get_ciphersuite_id)
+MAKE_FUNCPTR(mbedtls_ssl_get_max_frag_len)
+MAKE_FUNCPTR(mbedtls_ssl_get_version)
+MAKE_FUNCPTR(mbedtls_ssl_handshake)
+MAKE_FUNCPTR(mbedtls_ssl_init)
+MAKE_FUNCPTR(mbedtls_ssl_read)
+MAKE_FUNCPTR(mbedtls_ssl_conf_authmode)
+MAKE_FUNCPTR(mbedtls_ssl_set_bio)
+MAKE_FUNCPTR(mbedtls_ssl_conf_endpoint)
+MAKE_FUNCPTR(mbedtls_ssl_set_hostname)
+MAKE_FUNCPTR(mbedtls_ssl_conf_max_version)
+MAKE_FUNCPTR(mbedtls_ssl_conf_min_version)
+MAKE_FUNCPTR(mbedtls_ssl_conf_rng)
+MAKE_FUNCPTR(mbedtls_ssl_write)
+MAKE_FUNCPTR(mbedtls_ssl_get_peer_cert)
+MAKE_FUNCPTR(mbedtls_ssl_config_init)
+MAKE_FUNCPTR(mbedtls_ssl_config_defaults)
+MAKE_FUNCPTR(mbedtls_ssl_conf_dbg)
+MAKE_FUNCPTR(mbedtls_ssl_setup)
+MAKE_FUNCPTR(mbedtls_cipher_info_from_type)
+MAKE_FUNCPTR(mbedtls_md_info_from_type)
+MAKE_FUNCPTR(mbedtls_pk_get_bitlen)
+MAKE_FUNCPTR(mbedtls_ctr_drbg_seed)
 
 #undef MAKE_FUNCPTR
 
@@ -68,28 +78,38 @@
         goto fail; \
     }
 
-	LOAD_FUNCPTR(ctr_drbg_free)
-	LOAD_FUNCPTR(ctr_drbg_init)
-	LOAD_FUNCPTR(ctr_drbg_random)
-	LOAD_FUNCPTR(entropy_free)
-	LOAD_FUNCPTR(entropy_func)
-	LOAD_FUNCPTR(entropy_init)
-	LOAD_FUNCPTR(ssl_ciphersuite_from_id)
-	LOAD_FUNCPTR(ssl_free)
-	LOAD_FUNCPTR(ssl_get_ciphersuite)
-	LOAD_FUNCPTR(ssl_get_ciphersuite_id)
-	LOAD_FUNCPTR(ssl_get_version)
-	LOAD_FUNCPTR(ssl_handshake)
-	LOAD_FUNCPTR(ssl_init)
-	LOAD_FUNCPTR(ssl_read)
-	LOAD_FUNCPTR(ssl_set_authmode)
-	LOAD_FUNCPTR(ssl_set_bio)
-	LOAD_FUNCPTR(ssl_set_endpoint)
-	LOAD_FUNCPTR(ssl_set_hostname)
-	LOAD_FUNCPTR(ssl_set_max_version)
-	LOAD_FUNCPTR(ssl_set_min_version)
-	LOAD_FUNCPTR(ssl_set_rng)
-	LOAD_FUNCPTR(ssl_write)
+    LOAD_FUNCPTR(mbedtls_ctr_drbg_free)
+    LOAD_FUNCPTR(mbedtls_ctr_drbg_init)
+    LOAD_FUNCPTR(mbedtls_ctr_drbg_random)
+    LOAD_FUNCPTR(mbedtls_entropy_free)
+    LOAD_FUNCPTR(mbedtls_entropy_func)
+    LOAD_FUNCPTR(mbedtls_entropy_init)
+    LOAD_FUNCPTR(mbedtls_ssl_ciphersuite_from_id)
+    LOAD_FUNCPTR(mbedtls_ssl_free)
+    LOAD_FUNCPTR(mbedtls_ssl_get_ciphersuite)
+    LOAD_FUNCPTR(mbedtls_ssl_get_ciphersuite_id)
+    LOAD_FUNCPTR(mbedtls_ssl_get_max_frag_len)
+    LOAD_FUNCPTR(mbedtls_ssl_get_version)
+    LOAD_FUNCPTR(mbedtls_ssl_handshake)
+    LOAD_FUNCPTR(mbedtls_ssl_init)
+    LOAD_FUNCPTR(mbedtls_ssl_read)
+    LOAD_FUNCPTR(mbedtls_ssl_conf_authmode)
+    LOAD_FUNCPTR(mbedtls_ssl_set_bio)
+    LOAD_FUNCPTR(mbedtls_ssl_conf_endpoint)
+    LOAD_FUNCPTR(mbedtls_ssl_set_hostname)
+    LOAD_FUNCPTR(mbedtls_ssl_conf_max_version)
+    LOAD_FUNCPTR(mbedtls_ssl_conf_min_version)
+    LOAD_FUNCPTR(mbedtls_ssl_conf_rng)
+    LOAD_FUNCPTR(mbedtls_ssl_write)
+    LOAD_FUNCPTR(mbedtls_ssl_get_peer_cert)
+    LOAD_FUNCPTR(mbedtls_ssl_config_init)
+    LOAD_FUNCPTR(mbedtls_ssl_config_defaults)
+    LOAD_FUNCPTR(mbedtls_ssl_conf_dbg)
+    LOAD_FUNCPTR(mbedtls_ssl_setup)
+    LOAD_FUNCPTR(mbedtls_cipher_info_from_type)
+    LOAD_FUNCPTR(mbedtls_md_info_from_type)
+    LOAD_FUNCPTR(mbedtls_pk_get_bitlen)
+    LOAD_FUNCPTR(mbedtls_ctr_drbg_seed)
 
 #undef LOAD_FUNCPTR
 
@@ -112,30 +132,40 @@
 /* now that we have overridden the initialization functions
    cancel out the original stubs used when dynamically linking */
 
-#define schan_imp_init          schan_imp_init_unused
-#define schan_imp_deinit        schan_imp_deinit_unused
+#define schan_imp_init                  schan_imp_init_unused
+#define schan_imp_deinit                schan_imp_deinit_unused
 
 /* seamlessly redirect the function pointers with some preprocessor magic */
 
-#define ctr_drbg_free           pctr_drbg_free
-#define ctr_drbg_init           pctr_drbg_init
-#define ctr_drbg_random         pctr_drbg_random
-#define entropy_free            pentropy_free
-#define entropy_func            pentropy_func
-#define entropy_init            pentropy_init
-#define ssl_ciphersuite_from_id pssl_ciphersuite_from_id
-#define ssl_free                pssl_free
-#define ssl_get_ciphersuite     pssl_get_ciphersuite
-#define ssl_get_ciphersuite_id  pssl_get_ciphersuite_id
-#define ssl_get_version         pssl_get_version
-#define ssl_handshake           pssl_handshake
-#define ssl_init                pssl_init
-#define ssl_read                pssl_read
-#define ssl_set_authmode        pssl_set_authmode
-#define ssl_set_bio             pssl_set_bio
-#define ssl_set_endpoint        pssl_set_endpoint
-#define ssl_set_hostname        pssl_set_hostname
-#define ssl_set_max_version     pssl_set_max_version
-#define ssl_set_min_version     pssl_set_min_version
-#define ssl_set_rng             pssl_set_rng
-#define ssl_write               pssl_write
\ No newline at end of file
+#define mbedtls_ctr_drbg_free           mbedtls_ctr_drbg_free
+#define mbedtls_ctr_drbg_init           mbedtls_ctr_drbg_init
+#define mbedtls_ctr_drbg_random         mbedtls_ctr_drbg_random
+#define mbedtls_entropy_free            mbedtls_entropy_free
+#define mbedtls_entropy_func            mbedtls_entropy_func
+#define mbedtls_entropy_init            mbedtls_entropy_init
+#define mbedtls_ssl_ciphersuite_from_id mbedtls_ssl_ciphersuite_from_id
+#define mbedtls_ssl_free                mbedtls_ssl_free
+#define mbedtls_ssl_get_ciphersuite     mbedtls_ssl_get_ciphersuite
+#define mbedtls_ssl_get_ciphersuite_id  mbedtls_ssl_get_ciphersuite_id
+#define mbedtls_ssl_get_max_frag_len    mbedtls_ssl_get_max_frag_len
+#define mbedtls_ssl_get_version         mbedtls_ssl_get_version
+#define mbedtls_ssl_handshake           mbedtls_ssl_handshake
+#define mbedtls_ssl_init                mbedtls_ssl_init
+#define mbedtls_ssl_read                mbedtls_ssl_read
+#define mbedtls_ssl_conf_authmode       mbedtls_ssl_conf_authmode 
+#define mbedtls_ssl_set_bio             mbedtls_ssl_set_bio
+#define mbedtls_ssl_conf_endpoint       mbedtls_ssl_conf_endpoint
+#define mbedtls_ssl_set_hostname        mbedtls_ssl_set_hostname
+#define mbedtls_ssl_conf_max_version    mbedtls_ssl_conf_max_version
+#define mbedtls_ssl_conf_min_version    mbedtls_ssl_conf_min_version
+#define mbedtls_ssl_conf_rng            mbedtls_ssl_conf_rng
+#define mbedtls_ssl_write               mbedtls_ssl_write
+#define mbedtls_ssl_get_peer_cert       mbedtls_ssl_get_peer_cert
+#define mbedtls_ssl_config_init         mbedtls_ssl_config_init
+#define mbedtls_ssl_config_defaults     mbedtls_ssl_config_defaults
+#define mbedtls_ssl_conf_dbg            mbedtls_ssl_conf_dbg
+#define mbedtls_ssl_setup               mbedtls_ssl_setup
+#define mbedtls_cipher_info_from_type   mbedtls_cipher_info_from_type      
+#define mbedtls_md_info_from_type       mbedtls_md_info_from_type
+#define mbedtls_pk_get_bitlen           mbedtls_pk_get_bitlen
+#define mbedtls_ctr_drbg_seed           mbedtls_ctr_drbg_seed
\ No newline at end of file
Index: include/psdk/wincrypt.h
===================================================================
--- include/psdk/wincrypt.h	(revisión: 69439)
+++ include/psdk/wincrypt.h	(copia de trabajo)
@@ -1688,6 +1688,7 @@
 #define ALG_TYPE_STREAM                 (4 << 9)
 #define ALG_TYPE_DH                     (5 << 9)
 #define ALG_TYPE_SECURECHANNEL          (6 << 9)
+#define ALG_TYPE_DH_EPHEM               (7 << 9) /* FIXME: find the real TYPE name */
 
 /* SIDs */
 #define ALG_SID_ANY                     (0)
@@ -1718,12 +1719,13 @@
 #define ALG_SID_AES_192                15
 #define ALG_SID_AES_256                16
 #define ALG_SID_AES                    17
-/* Diffie-Hellmans SIDs */
+/* Diffie-Hellman SIDs */
 #define ALG_SID_DH_SANDF                1
 #define ALG_SID_DH_EPHEM                2
 #define ALG_SID_AGREED_KEY_ANY          3
 #define ALG_SID_KEA                     4
 #define ALG_SID_ECDH                    5
+#define ALG_SID_ECDH_EPHEM              6 /* FIXME: find the real SID name */
 /* RC2 SIDs */
 #define ALG_SID_RC4                     1
 #define ALG_SID_RC2                     2
@@ -1775,6 +1777,7 @@
 #define CALG_DH_EPHEM             (ALG_CLASS_KEY_EXCHANGE | ALG_TYPE_DH            | ALG_SID_DH_EPHEM)
 #define CALG_RSA_KEYX             (ALG_CLASS_KEY_EXCHANGE | ALG_TYPE_RSA           | ALG_SID_RSA_ANY)
 #define CALG_ECDH                 (ALG_CLASS_KEY_EXCHANGE | ALG_TYPE_DH            | ALG_SID_ECDH)
+#define CALG_ECDH_EPHEM           (ALG_CLASS_KEY_EXCHANGE | ALG_TYPE_DH_EPHEM      | ALG_SID_ECDH_EPHEM) /* FIXME: find the original TYPE and SID names, the flags were reverse engineered from a 0x0000ae06 constant in MSDN */
 #define CALG_ECMQV                (ALG_CLASS_KEY_EXCHANGE | ALG_TYPE_ANY           | ALG_SID_ECMQV)
 #define CALG_DES                  (ALG_CLASS_DATA_ENCRYPT | ALG_TYPE_BLOCK         | ALG_SID_DES)
 #define CALG_RC2                  (ALG_CLASS_DATA_ENCRYPT | ALG_TYPE_BLOCK         | ALG_SID_RC2)
